/*!
 * Author : Matteo Bruni
 * MIT license: https://opensource.org/licenses/MIT
 * Demo / Generator : https://particles.js.org/
 * GitHub : https://www.github.com/matteobruni/tsparticles
 * How to use? : Check the GitHub README
 * v3.0.0-alpha.0
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@tsparticles/engine"));
	else if(typeof define === 'function' && define.amd)
		define(["@tsparticles/engine"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@tsparticles/engine")) : factory(root["window"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__533__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 533:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__533__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "loadMultilineTextShape": () => (/* binding */ loadMultilineTextShape)
});

// EXTERNAL MODULE: external {"commonjs":"@tsparticles/engine","commonjs2":"@tsparticles/engine","amd":"@tsparticles/engine","root":"window"}
var engine_root_window_ = __webpack_require__(533);
;// CONCATENATED MODULE: ./dist/browser/MultilineTextDrawer.js

class MultilineTextDrawer {
  draw(context, particle, radius, opacity) {
    var _a, _b, _c;
    const character = particle.shapeData;
    if (character === undefined) {
      return;
    }
    const textData = character.value;
    if (textData === undefined) {
      return;
    }
    const textParticle = particle;
    if (textParticle.text === undefined) {
      textParticle.text = (0,engine_root_window_.itemFromSingleOrMultiple)(textData, particle.randomIndexData);
    }
    const text = textParticle.text,
      style = (_a = character.style) !== null && _a !== void 0 ? _a : "",
      weight = (_b = character.weight) !== null && _b !== void 0 ? _b : "400",
      size = Math.round(radius) * 2,
      font = (_c = character.font) !== null && _c !== void 0 ? _c : "Verdana",
      fill = particle.fill;
    context.font = `${style} ${weight} ${size}px "${font}"`;
    const lines = text === null || text === void 0 ? void 0 : text.split("\n");
    if (!lines) {
      return;
    }
    context.globalAlpha = opacity;
    for (let i = 0; i < lines.length; i++) {
      this._drawLine(context, lines[i], radius, opacity, i, fill);
    }
    context.globalAlpha = 1;
  }
  async init(container) {
    const options = container.options,
      shapeType = "multiline-text";
    if ((0,engine_root_window_.isInArray)(shapeType, options.particles.shape.type)) {
      const shapeOptions = options.particles.shape.options[shapeType],
        promises = [];
      (0,engine_root_window_.executeOnSingleOrMultiple)(shapeOptions, shape => {
        promises.push((0,engine_root_window_.loadFont)(shape.font, shape.weight));
      });
      await Promise.all(promises);
    }
  }
  _drawLine(context, line, radius, opacity, index, fill) {
    const offsetX = line.length * radius / 2,
      pos = {
        x: -offsetX,
        y: radius / 2
      };
    if (fill) {
      context.fillText(line, pos.x, pos.y + radius * 2 * index);
    } else {
      context.strokeText(line, pos.x, pos.y + radius * 2 * index);
    }
  }
}
;// CONCATENATED MODULE: ./dist/browser/index.js

function loadMultilineTextShape(engine) {
  engine.addShape("multiline-text", new MultilineTextDrawer());
}
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});